﻿unit form1;

interface

uses
  qtx.sysutils,
  qtx.classes,
  qtx.dom.types,
  qtx.dom.events,
  qtx.dom.graphics,
  qtx.dom.widgets,
  qtx.dom.theme,
  qtx.dom.application,
  qtx.dom.forms,

  qtx.dom.control.ulist;

type

  Tform1 = class(TQTXForm)
  {$I "intf::form1"}
  protected
    procedure InitializeObject; override;
    procedure FinalizeObject; override;
    procedure StyleObject; override;
  public

  end;

implementation uses qtx.dom.stylesheet;

const C_Items: Array[0..5] of string=(
 'Watch Now', 'Movies', 'TV Shows', 'Sports', 'Kids', 'Library');

procedure Tform1.InitializeObject;
begin
  inherited;
  {$I "impl::form1"}
  TQTXDOMUList.Create(self, procedure(List: TQTXDOMUList)
  begin
   for var i := 0 to high(C_Items) do
    TQTXDOMLItem.Create(List, procedure(Item: TQTXDOMLItem)
    begin
     Item.InnerHtml := C_Items[i];
    end);
  end);
end;

procedure Tform1.FinalizeObject;
begin
  inherited;
end;

procedure Tform1.StyleObject;
begin
  inherited;
  PositionMode := TQTXWidgetPositionMode.cpInitial;
  DisplayMode := TQTXWidgetDisplayMode.cdBlock;
end;

Initialization
begin
  var lSheet := TQTXCSSRules.Global;
  lSheet.AddStyles(#'
   body {
    background: url("https://hdqwalls.com/download/stranger-things-season-3-2019-4k-5k-38-1920x1080.jpg") center/cover no-repeat;
    height: 100vh;
    margin: 0;
    display: flex;
    justify-content: center;
  }

  .TQTXForm {
    padding: 2px;
    background-color: transparent;
    -moz-transform: none;
    -ms-transform: none;
    -o-transform: none;
  }

  .TQTXDOMUList {
    border-radius: 25px;
    height: -webkit-fit-content;
    height: -moz-fit-content;
    height: fit-content;
    display: inline-flex;
    background-color: rgba(0, 0, 0, 0.4);
    -webkit-backdrop-filter: blur(10px);
    backdrop-filter: blur(10px);
    align-items: center;
    padding: 0 10px;
    margin: 50px 0 0 0;
  }
  .TQTXDOMUList li {
    list-style: none;
    color: white;
    font-family: sans-serif;
    font-weight: bold;
    padding: 12px 16px;
    margin: 0 8px;
    position: relative;
    cursor: pointer;
    white-space: nowrap;
    overflow: visible;
  }
  .TQTXDOMUList li::before {
    content: " ";
    position: absolute;
    top: 0;
    left: 0;
    height: 100%;
    width: 100%;
    z-index: -1;
    transition: 0.2s;
    border-radius: 25px;
  }
  .TQTXDOMUList li:hover {
    color: black;
  }
  .TQTXDOMUList li:hover::before {
    background: linear-gradient(to bottom, #e8edec, #d2d1d3);
    box-shadow: 0px 3px 20px 0px black;
    transform: scale(1.2);
  }
 ');
end.
