﻿unit qtx.dom.control.ulist;

interface

uses
  qtx.sysutils,
  qtx.classes,
  qtx.dom.stylesheet,
  qtx.dom.Graphics,
  qtx.dom.widgets,
  qtx.dom.types;

type
  TQTXDOMUList = class;
  TQTXDOMLItem = class;

  TQTXDOMUListConstructor = procedure (Widget: TQTXDOMUList);

  TQTXDOMLItemConstructor = procedure (Widget: TQTXDOMLItem);

  [RegisterWidget(pidBrowser, ccDOM)]
  [RegisterInfo('DOM unordered list widget, wraps the <ul> element')]
  TQTXDOMUList = class(TQTXWidget)
  protected
    function CreateElementInstance: TWidgetHandle; override;
  public
    constructor Create(AOwner: TQTXComponent; CB: TQTXDOMUListConstructor); reintroduce; virtual;
  end;

  [RegisterWidget(pidBrowser, ccDOM)]
  [RegisterInfo('DOM unordered list widget, wraps the <li> element')]
  TQTXDOMLItem = class(TQTXWidget)
  protected
    function CreateElementInstance: TWidgetHandle; override;
  public
    constructor Create(AOwner: TQTXComponent; CB: TQTXDOMLItemConstructor); reintroduce; virtual;
    procedure StyleObject; override;
  end;

implementation

function TQTXDOMUList.CreateElementInstance: TWidgetHandle;
begin
 asm
    @result = document.createElement("ul");
  end;
end;

constructor TQTXDOMUList.Create(AOwner: TQTXComponent; CB: TQTXDOMUListConstructor);
begin
 inherited Create(AOwner, procedure (Widget: TQTXWidget)
  begin
    if assigned(CB) then
      CB(self);
  end);
end;


function TQTXDOMLItem.CreateElementInstance: TWidgetHandle;
begin
 asm
    @result = document.createElement("li");
  end;
end;

constructor TQTXDOMLItem.Create(AOwner: TQTXComponent; CB: TQTXDOMLItemConstructor);
begin
 inherited Create(AOwner, procedure (Widget: TQTXWidget)
  begin
    if assigned(CB) then
      CB(self);
  end);
end;

procedure TQTXDOMLItem.StyleObject;
begin
 inherited;
 style.overflow := 'visible';
end;


end.
